;***************************************
;led-unit
;***************************************
;timebase 100ms
;
;0x84 = 100ms-counter
;0x78 = 100ms-flags

;Group == C-flags

;0x7b = led-flags
;0x7c =	led-on-soll counter
;0x7d = led-off-soll counter
;0x7e =	led-on-istcounter
;0x7f = led-off-istcounter
;
;flags
;.equ	led_on		=	0
;.equ	led_pulse	=	1
;.equ	led_short	=	2
;.equ	led_long	=	3
;.equ	led_off		=	4


led_unit:
	;
	lds	r16,0x78 ;78
	sbrs	r16,flag100msC
	rjmp	led_unitBK
	;100ms-flag gesetzt
	cbr	r16,1<<flag100msC
	sts	0x78,r16
	;
	;
	;nun whlen...
	lds	r16,0x7b
	sbrc	r16,led_on
	rjmp	_led_on
	sbrc	r16,led_pulse
	rjmp	_led_pulse
	sbrc	r16,led_short
	rjmp	_led_short
	sbrc	r16,led_long
	rjmp	_led_long
	sbrc	r16,led_off
	rjmp	_led_off
	rjmp	led_unitBK
	; led on
_led_on:
	cbi	portb,led
	rjmp	led_unitBK
	;
	;100ms on/ 1400ms off
_led_pulse:
	ldi	r20,1	;on-time
	ldi	r21,14	;off-time
	rjmp	_ledDO

	;300ms on/ 300ms off
_led_short:
	ldi	r20,3	;on-time
	ldi	r21,3	;off-time
	rjmp	_ledDO

	;on/off 1s
_led_long:
	ldi	r20,10	;on-time
	ldi	r21,10	;off-time
	rjmp	_ledDO

	;led off
_led_off:
	sbi	portb,led
	rjmp	led_unitBK

	;----------------------------------------
	;led-do
_ledDO:
	lds	r17,0x7e	;on-ist
	lds	r18,0x7f	;off-ist
	cp	r17,r20
	brsh	_ledDOOFF
	cbi	portb,led
	inc	r17
	sts	0x7e,r17
	;off-counter==0
	clr	r18
	sts	0x7f,r18
	rjmp	led_unitBK

_ledDOOFF:
	cp	r18,r21
	brsh	_led_DOON
	sbi	portb,led
	inc	r18
	sts	0x7f,r18
	rjmp	led_unitBK
_led_DOON:
	clr	r17
	sts	0x7e,r17
	rjmp	led_unitBK
	
led_unitBK:
	ret