;*******************************************
;soft u/d & abschalt-unit
;*******************************************

;0x75 = 1ms-flags
;0x79 =	1s-flags
;Group == B-flags


;flags
;0x73
;.equ	aktiv		=	0
;.equ	soft_up		=	1
;.equ	soft_dw		=	2
;.equ	auto_off	=	3


_soft_ud:
	;statusflags laden
	lds	r16,0x73
	sbrc	r16,soft_up
	rjmp	_soft_comeUP	;-> soft_up luft oder wird neu angefordert...
	sbrc	r16,soft_dw
	rjmp	_soft_comeDW	;-> soft_dw luft oder wird neu angefordert...
	sbrc	r16,aktiv
	rjmp	_soft_AB		;-> normaler systembetrieb, nun abschalttimer prfen
	rjmp	_soft_udBK
	;
	;--------------------
	;
	;
	;
_soft_comeUP:
	;0x69 = softup-time-sollwert *
	;0x6a = softup-time-istwert
	;
	;0x61 = phasecut-sollwert	
	;0x62 =	phasecut-sollwert backup	;...
	;
	;timebase 1ms
	;hochlaufzeit pro schritt == 1ms - 255ms
	;
	;flag aktiv setzen
	lds	r17,0x73
	sbrc	r17,aktiv	;noch nicht aktiv ???
	rjmp	_soft_comeUPxx	
	;phasenwert sichern
	lds	r18,0x61 ;phase-sollwert
	sts	0x62,r18	;backup
	;sollwert 10
	ldi	r18,10
	sts	0x61,r18 ;phase-sollwert
	sbr	r17,1<<aktiv
	sts	0x73,r17



_soft_comeUPxx:
	;
	;1ms flagvariable laden
	lds	r17,0x75
	sbrs	r17,flag1msB
	rjmp	_soft_udBK
	;flag gesetzt..
	cbr	r17,1<<flag1msB
	sts	0x75,r17
	;softup-time-counter prfen
	lds	r17,0x69 ;up-sollwert*
	lds	r16,0x6a ;up-istwert
	cp	r16,r17
	brsh	_soft_comeUPtrue ; istwert schwelle erreicht...
	;counter+1 & back
	inc	r16
	sts	0x6a,r16
	rjmp _soft_udBK
	;
	;counter=0 & phasenwert prfen
_soft_comeUPtrue:
	clr	r16
	sts	0x6a,r16
	;
	;
	lds	r17,0x61 ;phase-sollwert
	lds	r16,0x62 ;phase-sollwert-backup
	cp	r17,r16  ;phase-soll >= phase-backup ?
	brsh	_soft_comeUPready
	inc	r17
	sts	0x61,r17
	rjmp	_soft_udBK
	;fertig..
_soft_comeUPready:
	mov	r17,r16
	sts	0x61,r17
	;flags korrigieren
	lds	r17,0x73
	cbr	r17,1<<soft_up
	sts	0x73,r17
	;led long
	clr	r17
	sbr	r17,1<<led_long
	sts	0x7b,r17
	;
	;ABcounter == 0 (
	clr	r18
	sts	0x70,r18
	sts	0x6f,r18
	;
	rjmp	_soft_udBK
	;
	;------------------------------------------
	;
_soft_comeDW:
	;0x6b = softdw-time-sollwert *
	;0x6c = softdw-time-istwert
	;
	;0x61 = phasecut-sollwert	
	;0x62 =	phasecut-sollwert backup	;...
	;
	;timebase 1ms
	;laufzeit pro schritt == 1ms - 255ms

	;1ms flagvariable laden
	lds	r17,0x75
	sbrs	r17,flag1msB
	rjmp	_soft_udBK
	;flag gesetzt..
	cbr	r17,1<<flag1msB
	sts	0x75,r17
	;softdown-time-counter prfen
	lds	r17,0x6b ;dw-sollwert*
	lds	r16,0x6c ;dw-istwert
	cp	r16,r17
	brsh	_soft_comeDWtrue ; istwert schwelle erreicht...
	;counter+1 & back
	inc	r16
	sts	0x6c,r16
	rjmp _soft_udBK
	;
	;counter=0 & phasenwert prfen
_soft_comeDWtrue:
	clr	r16
	sts	0x6c,r16
	;
	;
	lds	r17,0x61 ;phase-sollwert
	lds	r16,0x62 ;phase-sollwert-backup
	cpi	r17,10	;unteres limit
	breq	_soft_comeDWready
	dec	r17
	sts	0x61,r17
	rjmp _soft_udBK
	;
_soft_comeDWready:
	;phase backup -> phase soll
	mov	r17,r16
	sts	0x61,r17
	;flags korrigieren
	lds	r17,0x73
	cbr	r17,1<<soft_dw
	cbr	r17,1<<aktiv
	sts	0x73,r17
	;aus...
	sbi	portb,pwr_out
	;led pulse
	clr	r17
	sbr	r17,1<<led_pulse
	sts	0x7b,r17
	;
	rjmp	_soft_udBK

	;
	;------------------------------------------
	;

_soft_AB:
;0x6d = auto-off-time-sollwert (H) *
;0x6e = auto-off-time-sollwert (L) *
;
;0x6f = auto-off-time-istwert  (H)
;0x70 = auto-off-time-istwert  (L)
	lds	r17,0x73
	sbrs	r17,auto_off
	rjmp _soft_udBK
	;1s flag checken
	lds	r17,0x79
	sbrs	r17,flag1sB
	rjmp _soft_udBK
	;flag gesetzt & sofort lschen
	cbr	r17,1<<flag1sB
	sts	0x79,r17
	;auto-off counter & sollwert laden
	lds	r16,0x6e	;(L)soll
	lds	r17,0x6d	;(H)soll
	lds	r18,0x70	;(L)ist
	lds	r19,0x6f	;(H)ist
	;vergleiche soll == ist
	cp	r18,r16	;Compare low byte
	cpc	r19,r17	;Compare high byte with carry from
				;previous operation
	breq	_soft_ABok
	;ist-counter +1
	clr	r17
	ldi	r16,1
	add	r18, r16		;Add low bytes
	adc	r19, r17		;Add high bytes with carry
	;counter speichern
	sts	0x70,r18
	sts	0x6f,r19
	rjmp	_soft_udBK
	;
_soft_ABok:
	;soft-dw anschlieend einleiten
	lds	r17,0x73
	sbr	r17,1<<soft_dw
	sts	0x73,r17
	rjmp	_soft_udBK
	;
	;und raus...
_soft_udBK:
		ret