;**********************************
;Intelligent Phasecut Unit
;7/04
;**********************************

.include	"2313def.inc"

;
.def	timiVAR		=	r25	;timer-loop-counter variable
;
;__________
.equ	PWR_out		=	4	;PB4
.equ	LED			=	2	;PB2	
.equ	KEY			=	0	;PB0
.equ	RC5			=	6	;PD6
.equ	S_LOW			=	2	;PD2
.equ	S_HIGH		=	3	;PD3
.equ	INDI_L		=	5	;PB5
.equ	INDI_H		=	6	;PB6
.equ	INDI_55mic		=	3	;PB3

	
;
.equ	tiREL			=	206

;__________
;SRAM - 
;(*)=e2prom gespiegelt
;
;0x60 = 55,3s-flags & zero-flag
;
;0x61 = phasecut-sollwert	
;0x62 =	phasecut-sollwert backup	;...
;
;0x63 = phasecut-maximalwert			
;0x64 = phasecut-maximalwert backup
	
;0x65 = phasecut-istwert
;0x67 = phasecut-istwert backup
;
;0x69 = softup-time-sollwert *
;0x6a = softup-time-istwert

;0x6b = softdown-time-sollwert *
;0x6c = softdown-time-istwert
;
;0x6d = auto-off-time-sollwert (H) *
;0x6e = auto-off-time-sollwert (L) *
;
;0x6f = auto-off-time-istwert  (H)
;0x70 = auto-off-time-istwert  (L)
;
;0x71 = key-time-sollwert 
;0x72 = key-time-istwert
;
;0x73 = soft-ud-flagvariable
;0x74 = key-flagvariable
;
;0x75 = 1ms-flags
;0x76 = 10ms-flags
;0x77 = 20ms-flags
;0x78 = 100ms-flags
;0x79 =	1s-flags
;
;0x7a = phase-sollwert-counter	;fr soft u/d
;
;0x7b = led-flags
;0x7c =	led-on-sollcounter
;0x7d = led-off-sollcounter
;0x7e =	led-on-istcounter
;0x7f = led-off-istcounter
;
;0x80 = 55,5S-counter
;0x81 = 1ms-counter
;0x82 = 10ms-counter
;0x83 = 20ms-counter
;0x84 = 100ms-counter
;0x85 = 1s-counter
;
;0x86 =	rc5-decFLAG
;0x87 = rc5state
;0x88 =	rc5-biSTEP
;0x89 = rc5 adresse
;0x8a =	rc5 daten
;0x8b = rc5 daten BK
;0x8c = programmier-prozesscounter
;
;0x8d =	adresse(L)
;0x8e = """""""(H)

;0x8f =	parameter(L)
;0x90 = parameter(H)


;flags
;0x73
.equ	aktiv		=	0
.equ	soft_up	=	1
.equ	soft_dw	=	2
.equ	auto_off	=	3

 
;flags
;0x74
.equ	short_key	=	0
.equ	long_up	=	1
.equ	key_good	=	2
.equ	prog		=	3


;flags
;0x75
.equ	flag1msA	=	0
.equ	flag1msB	=	1
.equ	flag1msC	=	2
.equ	flag1msD	=	3
.equ	flag1msE	=	4
.equ	flag1msF	=	5
.equ	flag1msG	=	6
.equ	flag1msH	=	7


;flags
;0x76
.equ	flag10msA	=	0
.equ	flag10msB	=	1
.equ	flag10msC	=	2
.equ	flag10msD	=	3
.equ	flag10msE	=	4
.equ	flag10msF	=	5
.equ	flag10msG	=	6
.equ	flag10msH	=	7


;flags
;0x77
.equ	flag20msA	=	0
.equ	flag20msB	=	1
.equ	flag20msC	=	2
.equ	flag20msD	=	3
.equ	flag20msE	=	4
.equ	flag20msF	=	5
.equ	flag20msG	=	6
.equ	flag20msH	=	7


;flags
;0x78
.equ	flag100msA	=	0
.equ	flag100msB	=	1
.equ	flag100msC	=	2
.equ	flag100msD	=	3
.equ	flag100msE	=	4
.equ	flag100msF	=	5
.equ	flag100msG	=	6
.equ	flag100msH	=	7


;flags
;0x79
.equ	flag1sA	=	0
.equ	flag1sB	=	1
.equ	flag1sC	=	2
.equ	flag1sD	=	3
.equ	flag1sE	=	4
.equ	flag1sF	=	5
.equ	flag1sG	=	6
.equ	flag1sH	=	7

;flags
;0x7b 
.equ	led_on	=	0
.equ	led_pulse	=	1
.equ	led_short	=	2
.equ	led_long	=	3
.equ	led_off	=	4


;flags
;0x60
.equ	sys55clk	=	0
.equ	zeroA		=	1
.equ	zeroB		=	2
.equ	zeroX		=	3
.equ	phaseOK	=	4

;flags
;0x86
.equ	complete	=	0
.equ	toggle	=	1
.equ	toggleGLOBE	=	2

;
;

.cseg
.org	0
	rjmp	init		;reset vector
	rjmp	L_edge		;IRQ0 (ext0)
	rjmp	H_edge		;IRQ1 (ext1)
	nop					;timer1  cap
	nop					;timer1  compA
	nop					;timer1  ovf
	rjmp	_timiLOOP	;timer0 	ovf
	nop					;uart rx
	nop					;uart udre
	nop					;uart tx
	nop					;ana
	rjmp	_mainLOOP

;.equ	RESET	=$000	;External/Internal Hardware-Reset
;.equ	INT0addr=$001	;External Interrupt0 Vector Address
;.equ	INT1addr=$002	;External Interrupt1 Vector Address
;.equ	ICP1addr=$003	;Input Capture1 Interrupt Vector Address
;.equ	OC1Aaddr=$004	;Output Compare1A Interrupt Vector Address
;.equ	OVF1addr=$005	;Overflow1 Interrupt Vector Address
;.equ	OVF0addr=$006	;Overflow0 Interrupt Vector Address
;.equ	URXCaddr=$007	;UART Receive Complete Interrupt Vector Address
;.equ	UDREaddr=$008	;UART Data Register Empty Interrupt Vector Address
;.equ	UTXCaddr=$009	;UART Transmit Complete Interrupt Vector Address
;.equ	ACIaddr =$00a	;Analog Comparator Interrupt Vector Address



init:	
	
	ldi	r16,ramend
	out	spl,r16		;set spl
	;sram lschen 128bytes
	clr	zh
	ldi	zl,0x60
	clr	timiVAR			;default wert
clr_loop:
	cpi	zl,ramend
	breq	init_go
	st	z+,timiVAR
	rjmp	clr_loop
	;
init_go:	

	;set port's
	ldi	r16,0b01111110	;portb 
	out	ddrb,r16		
	ldi	r16,0b11111111	;pb4(pin16)=pwr_out /pb2(pin14)=led /pb0(pin12)=key /pb5(pin17)=indiL
	out	portb,r16		;pb6(pin18)=indiH /pb3(pin15)=indi_55mic
	;
	ldi	r16,0b10110011
	out	ddrd,r16
	ldi	r16,0b11110011	;pd2(pin6)=int0 /pd3(pin7)=int1 /pd6(pin11)=rc5
	out	portd,r16

	
	;set mcucr
	ldi	r16,0b00001110	;init MCUCR INT0=falling edge
						;			INT1=rising edge
	out	mcucr,r16
	
	;set gimsk
	ldi	r16,0b11000000	;enable INT1(H) & INT0(L)
	out	gimsk,r16

	
	;set timer0
	;timer0 overflow-interrupt alle 56s
	;Fck(7,3728MHz)/8=921600Hz <=> 921600Hz/51= 18070Hz <=> 1/18070hz= 55,3s 

	clr	r16
	sbr	r16,1<<toie0	;enable overflow interrupt
	out	timsk,r16
	clr	r16
	sbr	r16,1<<cs01	
	out	tccr0,r16	;prescale /8
	
	ldi	r16,tiREL	;s reload 
	out	tcnt0,r16

	;dafaults
	clr	r17
	sbr	r17,1<<auto_off
	;test01
;	sbr	r17,1<<aktiv

	sts	0x73,r17
	;phasen-maximalwert-default
	ldi	r17,182
	sts	0x63,r17
	;phasen soll
	ldi		r21,75
	sts		0x61,r21
	sts		0x62,r21 ;phase-sollwert-backup

	;key-time soll 1s
	ldi	r17,50
	sts	0x71,r17
	
	rcall	_readE2p
	;led pulse
	clr	r17
	sbr	r17,1<<led_pulse
	sts	0x7b,r17
	;enable global interrupt....
	sei
	rjmp	_mainLOOP








_readE2p:
	;sub
	;parameter aus e2prom ins SRAM bertragen
	ldi	r21,1
_readVARe2prom:
	rcall	_RDe2
	sts		0x69,r19	;up-time
	inc	r21
	rcall	_RDe2
	sts		0x6b,r19	;dw-time
	inc	r21
	rcall	_RDe2
	sts		0x6e,r19	;auto-off L
	inc	r21
	rcall	_RDe2
	sts		0x6d,r19	;auto-off H
	ret
	;sub
_RDe2:
	sbic	eecr,eewe	; EEWE nicht gelscht ?
	rjmp	_RDe2			; warte...
	;out	eearh,r17
	out	eearl,r21		; adressierung e2prom
	sbi	eecr,eere		; bereite bertragung aus e2prom vor 
	in	r19,eedr		; kopiere daten aus e2prom nach r19
	ret





	;_____________________________________________________


	;hauptloop
_mainLOOP:
	rjmp	_mainLOOP



.include "time_loop.asm"
.include "interrupthandler.asm"
.include "phasecut_unit.asm"
.include "soft_ud.asm"
.include "key_decII.asm"
.include "led_unit.asm"
.include "RC5decoder.asm"




